unit trasa;   {15}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, StdCtrls;

type
  TGForm = class(TForm)
    Image: TImage;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    MainMenu: TMainMenu;
    Soubor: TMenuItem;
    SouborKonec: TMenuItem;
    Soubor1: TMenuItem;
    SouborOtevrit: TMenuItem;
    Nastaveni: TMenuItem;
    Legenda: TMenuItem;
    Panel: TPanel;
    ButtonMapa: TButton;
    ButtonUloz: TButton;
    SouborUlozit: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Memo: TMemo;
    procedure LegendaClick(Sender: TObject);
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
    procedure SouborKonecClick(Sender: TObject);
    procedure SouborClick(Sender: TObject);
    procedure SouborOtevritClick(Sender: TObject);
    procedure NastaveniClick(Sender: TObject);
    procedure SouborUlozitClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const postup=[':','C'];
var
  GForm: TGForm;
  SpeedX,SpeedY:Byte;
  MaxX,MaxY:Byte;
  x,y:byte;
  data:array[0..255,0..255]of char;

implementation

uses legenda, nastaveni;

{$R *.dfm}

procedure step(sx,sy:integer);
var i,ii:integer;
    s,ss:string;
begin
 i:=(SpeedX-sx)*-1;
 ii:=(SpeedY-sy)*-1;
 s:='';
 if i>=0 then s:=s+' '
         else s:=s+'-';
 str(abs(i),ss);
 s:=s+ss+',';
 if ii>=0 then s:=s+' '
          else s:=s+'-';
 str(abs(ii),ss);
 s:=s+ss;
 GForm.memo.Lines.Add(s);
 SpeedX:=SpeedX+i;
 SpeedY:=SpeedY+ii;
 Trasa.x:=Trasa.x+SpeedX;
 Trasa.y:=Trasa.y+SpeedY;
 end;

procedure TGForm.LegendaClick(Sender: TObject);
begin
try
 FormLegend.Show;
except
 Application.CreateForm(TFormLegend, FormLegend);
 legenda.Click;
 end;
end;

procedure TGForm.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
Image.Visible:=NewWidth>238;
end;

procedure TGForm.SouborKonecClick(Sender: TObject);
begin
close;
end;

procedure TGForm.SouborClick(Sender: TObject);
begin
SouborUlozit.Enabled:=ButtonUloz.Enabled;
end;

procedure TGForm.SouborOtevritClick(Sender: TObject);
var f:file of char;
    c:char;
    x,y:integer;
    MaS,MaC:boolean;
    r:TRect;
    i:integer;
begin
OpenDialog.FilterIndex:=1;
if OpenDialog.Execute then begin
 AssignFile(f,OpenDialog.FileName);
 reset(f);
 MaxX:=0;
 MaxY:=0;
 x:=0;
 y:=0;
 MaS:=false;
 MaC:=false;
 Image.Canvas.Brush.Style:=bsSolid;
 r.Left:=0;
 r.Top:=0;
 r.Right:=Image.Width;
 r.Bottom:=Image.Height;
 Image.Canvas.Brush.Color:=clBtnFace;
 Image.Canvas.FillRect(r);
 repeat
  read(f,c);
  r.Left:=x*FormNastaveni.SpinEdit1.Value;
  r.Top:=y*FormNastaveni.SpinEdit1.Value;
  r.Right:=r.Left+FormNastaveni.SpinEdit1.Value;
  r.Bottom:=r.Top+FormNastaveni.SpinEdit1.Value;
  case c of
   'X':Image.Canvas.Brush.Color:=clBLACK;
   '.':Image.Canvas.Brush.Color:=clGREEN;
   ':':Image.Canvas.Brush.Color:=clLIME;
   'S':begin
        if MaS then begin
         application.MessageBox('Vstupn soubor m vc zatk','Chyba',MB_OK or MB_ICONERROR);;
         exit;
         end;
        MaS:=True;
        Image.Canvas.Brush.Color:=clAQUA;
        end;
   'C':begin
        MaC:=True;
        Image.Canvas.Brush.Color:=clFuchsia;
        end;
   #13:begin
        inc(y);
        if MaxX=0 then MaxX:=x;
        if x<>MaxX then begin
         application.MessageBox('Rzn dlky dk ve vstupnm souboru','Chyba',MB_OK or MB_ICONERROR);
         exit;
         end;
        x:=0;
        end;
   #10:;
   else begin
         application.MessageBox('Neplatn znak ve vstupnm souboru','Chyba',MB_OK or MB_ICONERROR);
         exit;
         end;
   end;
  if c in['X','.',':','S','C'] then begin
   Data[x,y]:=c;
   Image.Canvas.FillRect(r);
   inc(x);
   end;
  until EOF(f);
 MaxY:=y;
 CloseFile(f);
 if not(MaS and MaC) then application.MessageBox('V souboru chyb start nebo cl','Chyba',MB_OK or MB_ICONERROR)
  else begin
   if 1<>FormNastaveni.RadioGroup1.ItemIndex then begin
   image.Top:=image.Top+Image.Height;
   Image.Height:=-image.Height;
   for i:=0 to (memo.Lines.Count-1) do
    if memo.Lines.Strings[i][5]='1' then
     if memo.Lines.Strings[i][4]='-' then memo.Lines.Strings[i]:=memo.Lines.Strings[i][1]+memo.Lines.Strings[i][2]+', '+memo.Lines.Strings[i][5]
                                     else memo.Lines.Strings[i]:=memo.Lines.Strings[i][1]+memo.Lines.Strings[i][2]+',-'+memo.Lines.Strings[i][5]
   end;
   for x:=0 to MaxX do
    for y:=0 to MaxY do
     if data[x,y]='S'then begin
      trasa.x:=x;
      trasa.y:=y;
      end;

   x:=trasa.x;
   y:=trasa.y;
   SpeedX:=0;
   SpeedY:=0;

   if FormNastaveni.CheckBox1.Checked then
    repeat
     if (data[x+1,y     ])in postup then step( 1, 0);
     if (data[x-1,y     ])in postup then step(-1, 0);
     if (data[x  ,y-MaxY])in postup then step( 0,-1);
     if (data[x-1,y-MaxY])in postup then step(-1,-1);
     if (data[x+1,y-MaxY])in postup then step( 1,-1);
     if (data[x  ,y+MaxY])in postup then step( 0,+1);
     if (data[x-1,y+MaxY])in postup then step(-1,+1);
     if (data[x+1,y+MaxY])in postup then step( 1,+1);
     until data[x,y]='C';




   if 1<>FormNastaveni.RadioGroup1.ItemIndex then begin
   image.Top:=image.Top+Image.Height;
   Image.Height:=-image.Height;
   for i:=0 to (memo.Lines.Count-1) do
    if memo.Lines.Strings[i][5]='1' then
     if memo.Lines.Strings[i][4]='-' then memo.Lines.Strings[i]:=memo.Lines.Strings[i][1]+memo.Lines.Strings[i][2]+', '+memo.Lines.Strings[i][5]
                                     else memo.Lines.Strings[i]:=memo.Lines.Strings[i][1]+memo.Lines.Strings[i][2]+',-'+memo.Lines.Strings[i][5]
   end;
   end;
 end;
end;

procedure TGForm.NastaveniClick(Sender: TObject);
var b:boolean;
    i:integer;
    by:byte;
begin
try
 b:=FormNastaveni.CheckBox1.Checked;
 i:=FormNastaveni.RadioGroup1.ItemIndex;
 By:=FormNastaveni.SpinEdit1.Value;
 if FormNastaveni.ShowModal=MrOK then begin
  if i<>FormNastaveni.RadioGroup1.ItemIndex then begin
   image.Top:=image.Top+Image.Height;
   Image.Height:=0-image.Height;
   for i:=0 to (memo.Lines.Count-1) do
    if memo.Lines.Strings[i][5]='1' then
     if memo.Lines.Strings[i][4]='-' then memo.Lines.Strings[i]:=memo.Lines.Strings[i][1]+memo.Lines.Strings[i][2]+', '+memo.Lines.Strings[i][5]
                                     else memo.Lines.Strings[i]:=memo.Lines.Strings[i][1]+memo.Lines.Strings[i][2]+',-'+memo.Lines.Strings[i][5]
   end;
  end else begin
  FormNastaveni.CheckBox1.Checked:=b;
  FormNastaveni.RadioGroup1.ItemIndex:=i;
  FormNastaveni.SpinEdit1.Value:=by;
  end;
except
 Application.CreateForm(TFormNastaveni, FormNastaveni);
 Nastaveni.Click;
 end;
end;
procedure TGForm.SouborUlozitClick(Sender: TObject);
begin
SaveDialog.FilterIndex:=1;
if SaveDialog.Execute then
 if (SaveDialog.FilterIndex=1)and(SaveDialog.FileName[length(SaveDialog.FileName)-3]<>'.') then memo.Lines.SaveToFile(SaveDialog.FileName+'.txt')
                             else memo.Lines.SaveToFile(SaveDialog.FileName);
end;

end.
